/*
* C_lib Copyright (C) 2021 Wael Karram.
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, version 3 of the License.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

/* Function implementations for printing arrays. */
#include "array_print.h"

/* This function is used to print an array of integers into stdout. */
/* If length is invalid, might exhibit undefined behavior. */
void print_integer_array(int *array, int length) {
	/* Sanity check. */
	if (array == NULL || length <= 0)
		return;

	/* Print. */
	int i;
	for (i = 0; i < length; i++)
		printf("%d ", array[i]);
	putchar('\n');
}
