/*
* C_lib Copyright (C) 2021 Wael Karram.
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, version 3 of the License.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

/* Function to swap void* objects. */
#include "swap_void.h"

/* This function swaps void* objects. */
/* Size should be > 0. */
/* Expect undefined behavior if conditions aren't met. */
extern inline void swap_void_ptr(void *first, void *second, size_t size) {
	/* Swap. */
	char *a = (char*)first, *b = (char*)second, c;
	while(size--) {
		c = a[size];
		a[size] = b[size];
		b[size] = c;
	}
}
